(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('@angular/router')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/platform-browser', '@angular/router'], factory) :
	(factory((global['ng-bootstrap-modal'] = {}),global.core,global.platformBrowser,global.router));
}(this, (function (exports,core,platformBrowser,router) { 'use strict';

var ModalService = /** @class */ (function () {
    /**
     * @param {?} router
     */
    function ModalService(router$$1) {
        this.router = router$$1;
    }
    /**
     * @param {?} name
     * @return {?}
     */
    ModalService.prototype.open = function (name) {
        this.router.navigate([{ outlets: { modal: [name] } }], { skipLocationChange: true });
    };
    /**
     * @return {?}
     */
    ModalService.prototype.close = function () {
        this.router.navigate([{ outlets: { modal: null } }], { skipLocationChange: true });
    };
    ModalService.decorators = [
        { type: core.Injectable },
    ];
    /**
     * @nocollapse
     */
    ModalService.ctorParameters = function () { return [
        { type: router.Router, decorators: [{ type: core.Inject, args: [router.Router,] },] },
    ]; };
    return ModalService;
}());

var ModalComponent = /** @class */ (function () {
    /**
     * @param {?} modalService
     */
    function ModalComponent(modalService) {
        this.modalService = modalService;
    }
    /**
     * @return {?}
     */
    ModalComponent.prototype.close = function () {
        this.modalService.close();
    };
    ModalComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'modal',
                    template: "\n    <div class=\"modal fade in show\" tabindex=\"-1\" role=\"dialog\">\n        <div class=\"modal-dialog modal-lg\" role=\"document\">\n          <div class=\"modal-content\">\n            <div class=\"modal-header\">\n              <button type=\"button\" (click)=\"close()\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\"><span aria-hidden=\"true\">&times;</span></button>\n              <h4 class=\"modal-title\">\n                <ng-content select=\"[modal-title]\"></ng-content>\n              </h4>\n            </div>\n            <div class=\"modal-body\">\n                <ng-content select=\"[modal-body]\"></ng-content>\n            </div>\n            <div class=\"modal-footer\">\n                <div #footer>\n                    <ng-content select=\"[modal-footer]\"></ng-content>\n                </div>\n                <div *ngIf=\"footer.children.length == 0\">\n                    <button (click)=\"close()\" type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Close</button>\n                    <button type=\"button\" class=\"btn btn-primary\">Submit</button>\n                </div>\n            </div>\n          </div>\n        </div>\n      </div>\n      <div class=\"modal-backdrop fade in\"></div>\n  "
                },] },
    ];
    /**
     * @nocollapse
     */
    ModalComponent.ctorParameters = function () { return [
        { type: ModalService, },
    ]; };
    return ModalComponent;
}());

var ModalOutletComponent = /** @class */ (function () {
    function ModalOutletComponent() {
    }
    ModalOutletComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'modal-outlet',
                    template: "\n    <router-outlet name=\"modal\"></router-outlet>\n  "
                },] },
    ];
    /**
     * @nocollapse
     */
    ModalOutletComponent.ctorParameters = function () { return []; };
    return ModalOutletComponent;
}());

var ModalModule = /** @class */ (function () {
    function ModalModule() {
    }
    /**
     * @param {?} modals
     * @return {?}
     */
    ModalModule.forRoot = function (modals) {
        var /** @type {?} */ routes = modals.map(function (t) {
            return { path: t.name, component: t.component, outlet: 'modal' };
        });
        var InternalModalModule = /** @class */ (function () {
            function InternalModalModule() {
            }
            InternalModalModule.decorators = [
                { type: core.NgModule, args: [{
                            imports: [
                                ModalModule,
                                router.RouterModule.forRoot(routes),
                            ],
                            exports: [
                                ModalModule
                            ]
                        },] },
            ];
            /**
             * @nocollapse
             */
            InternalModalModule.ctorParameters = function () { return []; };
            return InternalModalModule;
        }());
        return {
            ngModule: InternalModalModule,
            providers: [ModalService]
        };
    };
    ModalModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [platformBrowser.BrowserModule, router.RouterModule],
                    declarations: [
                        ModalComponent,
                        ModalOutletComponent
                    ],
                    exports: [
                        ModalComponent,
                        ModalOutletComponent
                    ]
                },] },
    ];
    /**
     * @nocollapse
     */
    ModalModule.ctorParameters = function () { return []; };
    return ModalModule;
}());

/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @module
 * @description
 * Entry point for all public APIs of the core package.
 */

/**
 * Generated bundle index. Do not edit.
 */

exports.ModalModule = ModalModule;
exports.ModalService = ModalService;
exports.ɵb = ModalOutletComponent;
exports.ɵa = ModalComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
